//---------------------------------------------------------------------------

#ifndef BackpropogationH
#define BackpropogationH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>

struct trainex{
	float input[3];
	float expected[3];
};

trainex minta[5]={
	0.1,0.2,0.2,0.5,0.1,0.1,
	0.2,0.1,0.3,0.1,0.1,0.5,
	2,2,2,0.1,0.5,0.2,
	6,9,9,0.0,0.2,0.2,
	1,9,7,0.0,0.1,0.3
};

class neu{
	public:
	float sum;
	float out;
	float w[4];//w[3] is threshold.
	float delta;
};

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TButton *Button1;
	TButton *Button2;
	TEdit *Edit1;
	TEdit *Edit2;
	TEdit *Edit3;
	TEdit *Edit4;
	TEdit *Edit5;
	TEdit *Edit6;
	TEdit *Edit7;
	TEdit *Edit8;
	TEdit *Edit9;
	TEdit *Edit10;
	TEdit *Edit11;
	TEdit *Edit14;
	TEdit *Edit15;
	TEdit *Edit16;
	TEdit *Edit17;
	TEdit *Edit18;
	TEdit *Edit19;
	TEdit *Edit20;
	TEdit *Edit21;
	TEdit *Edit22;
	TEdit *Edit23;
	TEdit *Edit24;
	TEdit *Edit25;
	TEdit *Edit26;
	TEdit *Edit12;
	TEdit *Edit13;
	TEdit *Edit27;
	TEdit *Edit28;
	TEdit *Edit29;
	TEdit *Edit30;
	TButton *Button3;
	TTrackBar *TrackBar1;
	TTrackBar *TrackBar2;
	TTrackBar *TrackBar3;
	TButton *Button4;
	TButton *Button5;
	TEdit *Edit31;
	TEdit *Edit32;
	TButton *Button6;
	TEdit *Edit33;
	TEdit *Edit34;
	TEdit *Edit35;
	TEdit *Edit36;
	TEdit *Edit37;
	TEdit *Edit38;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall Destroy(TObject *Sender);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall Button3Click(TObject *Sender);
	void __fastcall TrackBar1Change(TObject *Sender);
	void __fastcall TrackBar2Change(TObject *Sender);
	void __fastcall TrackBar3Change(TObject *Sender);
	void __fastcall Button4Click(TObject *Sender);
	void __fastcall Button5Click(TObject *Sender);
	void __fastcall Button6Click(TObject *Sender);
private:	// User declarations
	neu*layerinp[3];
//	neu*layermid[10];
	neu*layerout[3];
	float in[3];
	float expectedout[3];
	float etha;
	int displaypos;
	int examplec;
	float randweight();
	void propogate();
	float sig(float x);
	float sigmoid(float x);	
	float sig_diff(float x);
	void display();
	void guiupdate();
	void backprop();
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
